using Microsoft.AspNetCore.Antiforgery;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc.Filters;
using Microsoft.Extensions.DependencyInjection;

namespace TestProject.Filters
{
    /// <summary>
    ///   ū Ű  ƮƮ
    /// </summary>
    public class GenerateAntiforgeryTokenCookieAttribute : ResultFilterAttribute
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region   óϱ - OnResultExecuting(context)

        /// <summary>
        ///   óϱ
        /// </summary>
        /// <param name="context">  ؽƮ</param>
        public override void OnResultExecuting(ResultExecutingContext context)
        {
            IAntiforgery antiforgery = context.HttpContext.RequestServices.GetService<IAntiforgery>();

            // û ū JavaScript   ִ Ű .
            AntiforgeryTokenSet tokens = antiforgery.GetAndStoreTokens(context.HttpContext);

            context.HttpContext.Response.Cookies.Append
            (
                "RequestVerificationToken",
                tokens.RequestToken,
                new CookieOptions() { HttpOnly = false }
            );
        }

        #endregion
        #region   óϱ - OnResultExecuted(context)

        /// <summary>
        ///   óϱ
        /// </summary>
        /// <param name="context">  ؽƮ</param>
        public override void OnResultExecuted(ResultExecutedContext context)
        {
        }

        #endregion
    }
}