using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using System.Threading.Tasks;

using TestProject.Data;
using TestProject.Models;

namespace TestProject.Pages
{
    /// <summary>
    /// ͺ̽   
    /// </summary>
    public class DeleteFileFromDatabaseModel : PageModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ͺ̽ ؽƮ
        /// </summary>
        private readonly DatabaseContext databaseContext;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        [BindProperty]
        public FileItemModel RemoveFile { get; private set; }

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - DeleteFileFromDatabaseModel(databaseContext)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="databaseContext">ͺ̽ ؽƮ</param>
        public DeleteFileFromDatabaseModel(DatabaseContext databaseContext)
        {
            this.databaseContext = databaseContext;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  GET û óϱ (񵿱) - OnGetAsync(id)

        /// <summary>
        /// GET û óϱ (񵿱)
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>׼  ½ũ</returns>
        public async Task<IActionResult> OnGetAsync(int? id)
        {
            if(id == null)
            {
                return RedirectToPage("/Index");
            }

            RemoveFile = await this.databaseContext.FileItemDBSet.SingleOrDefaultAsync(m => m.ID == id);

            if(RemoveFile == null)
            {
                return RedirectToPage("/Index");
            }

            return Page();
        }

        #endregion
        #region POST û óϱ (񵿱) - OnPostAsync(id)

        /// <summary>
        /// POST û óϱ (񵿱)
        /// </summary>
        /// <param name="id">ID</param>
        /// <returns>׼ </returns>
        public async Task<IActionResult> OnPostAsync(int? id)
        {
            if(id == null)
            {
                return RedirectToPage("/Index");
            }

            RemoveFile = await this.databaseContext.FileItemDBSet.FindAsync(id);

            if(RemoveFile != null)
            {
                this.databaseContext.FileItemDBSet.Remove(RemoveFile);

                await this.databaseContext.SaveChangesAsync();
            }

            return RedirectToPage("/Index");
        }

        #endregion
    }
}