using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.FileProviders;

namespace TestProject.Pages
{
    /// <summary>
    ///  ҿ   
    /// </summary>
    public class DeleteFileFromPhysicalStorageModel : PageModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///  
        /// </summary>
        private readonly IFileProvider fileProvider;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region    - RemoveFile

        /// <summary>
        ///  
        /// </summary>
        public IFileInfo RemoveFile { get; private set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - DeleteFileFromPhysicalStorageModel(fileProvider)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="fileProvider"> </param>
        public DeleteFileFromPhysicalStorageModel(IFileProvider fileProvider)
        {
            this.fileProvider = fileProvider;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region GET û óϱ - OnGet(fileName)

        /// <summary>
        /// GET û óϱ
        /// </summary>
        /// <param name="fileName">ϸ</param>
        /// <returns>׼ </returns>
        public IActionResult OnGet(string fileName)
        {
            if(string.IsNullOrEmpty(fileName))
            {
                return RedirectToPage("/Index");
            }

            RemoveFile = this.fileProvider.GetFileInfo(fileName);

            if(!RemoveFile.Exists)
            {
                return RedirectToPage("/Index");
            }

            return Page();
        }

        #endregion
        #region POST û óϱ - OnPost(fileName)

        /// <summary>
        /// POST û óϱ
        /// </summary>
        /// <param name="fileName">ϸ</param>
        /// <returns>׼ </returns>
        public IActionResult OnPost(string fileName)
        {
            if(string.IsNullOrEmpty(fileName))
            {
                return RedirectToPage("/Index");
            }

            RemoveFile = this.fileProvider.GetFileInfo(fileName);

            if(RemoveFile.Exists)
            {
                System.IO.File.Delete(RemoveFile.PhysicalPath);
            }

            return RedirectToPage("./Index");
        }

        #endregion
    }
}