using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Threading.Tasks;

using TestProject.Data;
using TestProject.Models;
using TestProject.Utilities;

namespace TestProject.Pages
{
    /// <summary>
    /// ͺ̽   ټ  ε 
    /// </summary>
    public class UploadBufferMultipleFileToDatabaseModel : PageModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ͺ̽ ؽƮ
        /// </summary>
        private readonly DatabaseContext databaseContext;

        /// <summary>
        ///  ũ 
        /// </summary>
        private readonly long fileSizeLimit;

        /// <summary>
        ///   Ȯ 迭
        /// </summary>
        private readonly string[] allowFileExtensionArray = { ".txt" };

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ε - FileUpload

        /// <summary>
        ///  ε
        /// </summary>
        [BindProperty]
        public UploadBufferMultipleFileToDatabaseModelFileUploadInfo FileUpload { get; set; }

        #endregion
        #region  - Result

        /// <summary>
        /// 
        /// </summary>
        public string Result { get; private set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - UploadBufferMultipleFileToDatabaseModel(databaseContext, configuration)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="databaseContext">ͺ̽ ؽƮ</param>
        /// <param name="configuration"></param>
        public UploadBufferMultipleFileToDatabaseModel(DatabaseContext databaseContext, IConfiguration configuration)
        {
            this.databaseContext = databaseContext;
            this.fileSizeLimit   = configuration.GetValue<long>("FileSizeLimit");
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region GET û óϱ - OnGet()

        /// <summary>
        /// GET û óϱ
        /// </summary>
        public void OnGet()
        {
        }

        #endregion
        #region ε POST û óϱ (񵿱) - OnPostUploadAsync()

        /// <summary>
        /// ε POST û óϱ (񵿱)
        /// </summary>
        /// <returns>׼  ½ũ</returns>
        public async Task<IActionResult> OnPostUploadAsync()
        {
            // FileUpload Ŭ Ӽ  Ϸ ʱ ˻縦 Ѵ.
            if(!ModelState.IsValid)
            {
                Result = "Please correct the form.";

                return Page();
            }

            foreach(IFormFile formFile in FileUpload.FormFileList)
            {
                byte[] formFileContentByteArray = await FileHelper.ProcessFormFile<UploadBufferMultipleFileToDatabaseModelFileUploadInfo>
                (
                    formFile,
                    ModelState,
                    this.allowFileExtensionArray,
                    this.fileSizeLimit
                );

                //  ° ˻縦 Ͽ ProcessFormFile ޼  Ѵ.
                // ȿ ˻簡 ϸ  ư.
                if(!ModelState.IsValid)
                {
                    Result = "Please correct the form.";

                    return Page();
                }

                // !
                //     ĵ ʰ  ȴ.
                // κ δ ó  ٿεϰų ٸ ýۿ   ֵϱ 
                // ̷ /ֿ  ĳ API Ͽ ȴ.

                FileItemModel fileItem = new FileItemModel()
                {
                    Content    = formFileContentByteArray, 
                    FileName   = formFile.FileName, 
                    Note       = FileUpload.Note,
                    Size       = formFile.Length, 
                    UploadTime = DateTime.UtcNow
                };

                this.databaseContext.FileItemDBSet.Add(fileItem);

                await this.databaseContext.SaveChangesAsync();
            }

            return RedirectToPage("./Index");
        }

        #endregion
    }

    /// <summary>
    /// ͺ̽   ټ  ε   ε 
    /// </summary>
    public class UploadBufferMultipleFileToDatabaseModelFileUploadInfo
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region   Ʈ - FormFileList

        /// <summary>
        ///   Ʈ
        /// </summary>
        [Required]
        [Display(Name="")]
        public List<IFormFile> FormFileList { get; set; }

        #endregion
        #region Ʈ - Note

        /// <summary>
        /// Ʈ
        /// </summary>
        [Display(Name="Ʈ")]
        [StringLength(50, MinimumLength = 0)]
        public string Note { get; set; }

        #endregion
    }
}