using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration;
using System;
using System.ComponentModel.DataAnnotations;
using System.Threading.Tasks;

using TestProject.Data;
using TestProject.Models;
using TestProject.Utilities;

namespace TestProject.Pages
{
    /// <summary>
    /// ͺ̽   1  ε 
    /// </summary>
    public class UploadBufferOneFileToDatabaseModel : PageModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ͺ̽ ؽƮ
        /// </summary>
        private readonly DatabaseContext databaseContext;

        /// <summary>
        ///  ũ 
        /// </summary>
        private readonly long fileSizeLimit;

        /// <summary>
        ///   Ȯ 迭
        /// </summary>
        private readonly string[] allowFileExtensionArray = { ".txt" };

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ε - FileUpload

        /// <summary>
        ///  ε
        /// </summary>
        [BindProperty]
        public UploadBufferOneFileToDatabaseModelFileUploadInfo FileUpload { get; set; }

        #endregion
        #region  - Result

        /// <summary>
        /// 
        /// </summary>
        public string Result { get; private set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - UploadBufferOneFileToDatabaseModel(databaseContext, configuration)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="databaseContext">ͺ̽ ؽƮ</param>
        /// <param name="configuration"></param>
        public UploadBufferOneFileToDatabaseModel(DatabaseContext databaseContext, IConfiguration configuration)
        {
            this.databaseContext = databaseContext;
            this.fileSizeLimit   = configuration.GetValue<long>("FileSizeLimit");
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region GET û óϱ - OnGet()

        /// <summary>
        /// GET û óϱ
        /// </summary>
        public void OnGet()
        {
        }

        #endregion
        #region ε POST û óϱ (񵿱) - OnPostUploadAsync()

        /// <summary>
        /// ε POST û óϱ (񵿱)
        /// </summary>
        /// <returns>׼  ½ũ</returns>
        public async Task<IActionResult> OnPostUploadAsync()
        {
            // FileUpload Ŭ Ӽ  Ϸ ʱ ˻縦 Ѵ.
            if(!ModelState.IsValid)
            {
                Result = "Please correct the form.";

                return Page();
            }

            byte[] formFileContentByteArray = await FileHelper.ProcessFormFile<UploadBufferOneFileToDatabaseModelFileUploadInfo>
            (
                FileUpload.FormFile,
                ModelState,
                this.allowFileExtensionArray,
                this.fileSizeLimit
            );

            //  ° ˻縦 Ͽ ProcessFormFile ޼  Ѵ.
            // ȿ ˻簡 ϸ  ư.
            if(!ModelState.IsValid)
            {
                Result = "Please correct the form.";

                return Page();
            }

            // !
            //     ĵ ʰ  ȴ.
            // κ δ ó  ٿεϰų ٸ ýۿ   ֵϱ 
            // ̷ /ֿ  ĳ API Ͽ ȴ.

            FileItemModel fileItem = new FileItemModel
            {
                Content    = formFileContentByteArray, 
                FileName   = FileUpload.FormFile.FileName, 
                Note       = FileUpload.Note,
                Size       = FileUpload.FormFile.Length, 
                UploadTime = DateTime.UtcNow
            };

            this.databaseContext.FileItemDBSet.Add(fileItem);

            await this.databaseContext.SaveChangesAsync();

            return RedirectToPage("./Index");
        }

        #endregion
    }

    /// <summary>
    /// ͺ̽   1  ε   ε 
    /// </summary>
    public class UploadBufferOneFileToDatabaseModelFileUploadInfo
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region   - FormFile

        /// <summary>
        ///  
        /// </summary>
        [Required]
        [Display(Name="")]
        public IFormFile FormFile { get; set; }

        #endregion
        #region Ʈ - Note

        /// <summary>
        /// Ʈ
        /// </summary>
        [Display(Name="Ʈ")]
        [StringLength(50, MinimumLength = 0)]
        public string Note { get; set; }

        #endregion
    }
}