using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.IO;
using System.Threading.Tasks;

using TestProject.Utilities;

namespace TestProject.Pages
{
    /// <summary>
    ///  ҿ   2  ε 
    /// </summary>
    public class UploadBufferTwoFileToPhysicalStorageModel : PageModel
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ÿ 丮 
        /// </summary>
        private readonly string targetDirectoryPath;

        /// <summary>
        ///  ũ 
        /// </summary>
        private readonly long fileSizeLimit;

        /// <summary>
        ///   Ȯ 迭
        /// </summary>
        private readonly string[] allowFileExtensionArray = { ".txt" };

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ε - FileUpload

        /// <summary>
        ///  ε
        /// </summary>
        [BindProperty]
        public UploadBufferTwoFileToPhysicalStorageModelFileUploadInfo FileUpload { get; set; }

        #endregion
        #region  - Result

        /// <summary>
        /// 
        /// </summary>
        public string Result { get; private set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - UploadBufferTwoFileToPhysicalStorageModel(configuration)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="configuration"></param>
        public UploadBufferTwoFileToPhysicalStorageModel(IConfiguration configuration)
        {
            this.targetDirectoryPath = configuration.GetValue<string>("UploadDirectoryPath");

            this.fileSizeLimit = configuration.GetValue<long>("FileSizeLimit");
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region GET û óϱ - OnGet()

        /// <summary>
        /// GET û óϱ
        /// </summary>
        public void OnGet()
        {
        }

        #endregion
        #region ε POST û óϱ (񵿱) - OnPostUploadAsync()

        /// <summary>
        /// ε POST û óϱ (񵿱)
        /// </summary>
        /// <returns>׼  ½ũ</returns>
        public async Task<IActionResult> OnPostUploadAsync()
        {
            // FileUpload Ŭ Ӽ  Ϸ ʱ ˻縦 Ѵ.
            if(!ModelState.IsValid)
            {
                Result = "Please correct the form.";

                return Page();
            }

            List<IFormFile> formFileList = new List<IFormFile>()
            {
                FileUpload.FormFile1, 
                FileUpload.FormFile2
            };

            foreach(IFormFile formFile in formFileList)
            {
                byte[] formFileContentByteArray = await FileHelper.ProcessFormFile<UploadBufferTwoFileToPhysicalStorageModelFileUploadInfo>
                (
                    formFile,
                    ModelState,
                    this.allowFileExtensionArray,
                    this.fileSizeLimit
                );

                //  ° ˻縦 Ͽ ProcessFormFile ޼  Ѵ.
                // ȿ ˻簡 ϸ  ư.
                if(!ModelState.IsValid)
                {
                    Result = "Please correct the form.";

                    return Page();
                }

                var sourceFileName = formFile.FileName;
                var targetFilePath = Path.Combine(this.targetDirectoryPath, sourceFileName);

                // !
                //     ĵ ʰ  ȴ.
                // κ δ ó  ٿεϰų ٸ ýۿ   ֵϱ 
                // ̷ /ֿ  ĳ API Ͽ ȴ.

                using(FileStream fileStream = System.IO.File.Create(targetFilePath))
                {
                    await fileStream.WriteAsync(formFileContentByteArray);

                    // FormFile  ۾Ϸ   Ѵ :
                    //await formFile.CopyToAsync(fileStream);
                }
            }

            return RedirectToPage("./Index");
        }

        #endregion
    }

    /// <summary>
    ///  ҿ   2  ε   ε 
    /// </summary>
    public class UploadBufferTwoFileToPhysicalStorageModelFileUploadInfo
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region   1 - FormFile1

        /// <summary>
        ///   1
        /// </summary>
        [Required]
        [Display(Name=" 1")]
        public IFormFile FormFile1 { get; set; }

        #endregion
        #region   2 - FormFile2

        /// <summary>
        ///   2
        /// </summary>
        [Required]
        [Display(Name=" 2")]
        public IFormFile FormFile2 { get; set; }

        #endregion
        #region Ʈ - Note

        /// <summary>
        /// Ʈ
        /// </summary>
        [Display(Name="Ʈ")]
        [StringLength(50, MinimumLength = 0)]
        public string Note { get; set; }

        #endregion
    }
}